# scroll-parallax-effect

スクロールによって css の値を変更することができるプラグインです。

This plugin allows you to change css values by scrolling.

## このプラグインには 3 つの機能があります。

- [Timing](docs/#timing-usage) : 指定 位置を通過したときにクラスを追加します
- [Speed](docs/#speed-usage) : スクロール量に応じて css を変化させる
- [Fit](docs/#fit-usage) : 移動距離に応じて css を変化させる

## This plugin has three functions.

- [Timing](docs/#timing-usage) : add a class when passing a specified position
- [Speed](docs/#speed-usage) : css changes according to the amount of scrolling
- [Fit](docs/#fit-usage) : change css according to distance traveled

## Install

### npm

```terminal
npm install scroll-parallax-effect
```

### yarn

```terminal
yarn add scroll-parallax-effect
```

## Document and Examples

[Document and Examples](docs/)

- [typescript](docs/TYPESCRIPT_ES6_VANILLA.md)
- [vue](docs/VUE.md)
- [svg](docs/SVG.md)

## Example

### Typescript
- [y scroll sample](http://kamem.github.io/scroll-parallax-effect/docs/example/typescript/y-typescript.html)
- [x scroll sample](http://kamem.github.io/scroll-parallax-effect/docs/example/typescript/x-typescript.html)

### Vanilla

- [y scroll sample](http://kamem.github.io/scroll-parallax-effect/docs/example/vanilla/y-vanilla.html)
- [x scroll sample](http://kamem.github.io/scroll-parallax-effect/docs/example/vanilla/x-vanilla.html)

### SVG

- [y scroll sample](http://kamem.github.io/scroll-parallax-effect/docs/example/svg/svg.html)

## Development

### serve

```
yarn serve
```

### build

```
npm run build
```

or

```
yarn build
```

### test

```
yarn test
```

## Previous versions
https://github.com/kamem/scrollParallax
